# TODO:
# - add -n mod_wsgi-express package
#   https://github.com/GrahamDumpleton/mod_wsgi#installation-into-python

%define		mod_name	wsgi
%define		apxs		/usr/sbin/apxs
Summary:	WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI dla serwera WWW Apache
Name:		apache-mod_%{mod_name}
Version:	5.0.2
Release:	1
License:	Apache
Group:		Networking/Daemons
Source0:	https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}/mod_%{mod_name}-%{version}.tar.gz
# Source0-md5:	010aea46c3896d7a847db9fc402623e9
Source1:	%{name}.conf
URL:		http://www.modwsgi.org/
BuildRequires:	%{apxs}
BuildRequires:	apache-devel >= 2.4
BuildRequires:	apr-devel >= 1:1.0.0
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	python3-devel >= 1:3.8
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_pkglibdir	%(%{apxs} -q LIBEXECDIR 2>/dev/null)
%define		_sysconfdir	%(%{apxs} -q SYSCONFDIR 2>/dev/null)/conf.d

%description
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%package py3
Summary:	Python 3.x WSGI interface for the Apache Web server
Summary(pl.UTF-8):	Interfejs WSGI Pythona 3.x dla serwera WWW Apache
Group:		Networking/Daemons
Requires:	apache(modules-api) = %{apache_modules_api}
Requires:	apr >= 1:1.0.0
Requires:	python3-modules >= 1:3.8
Provides:	apache(mod_wsgi) = %{version}-%{release}
Conflicts:	apache-mod_wsgi < 4.5.7-0.2
Conflicts:	%{name}-py2
# http://helpful.knobs-dials.com/index.php/Mod_wsgi_notes#PyEval_AcquireThread:_non-NULL_old_thread_state
Conflicts:	apache-mod_python3

%description py3
The mod_wsgi adapter is an Apache module that provides a WSGI
compliant interface for hosting Python based web applications within
Apache. The adapter is written completely in C code against the Apache
C runtime and for hosting WSGI applications within Apache has a lower
overhead than using existing WSGI adapters for mod_python or CGI.

%description py3 -l pl.UTF-8
Adapter mod_wsgi jest modułem udostępniającym interfejs WSGI dla
aplikacji WWW napisanych w języku Python i osadzonych w serwerze
Apache. Adapter jest w całości napisany w języku C w oparciu o
bibliotekę uruchomieniową Apache i ma mniejsze wymagania niż w
przypadku używania istniejących adapterów WSGI dla modułu mod_python
lub CGI.

%prep
%setup -q -n mod_%{mod_name}-%{version}

%build
%{__aclocal}
%{__autoconf}
%configure \
	--with-python=%{__python3} \
	--with-apxs=%{apxs}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_pkglibdir},%{_sysconfdir}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_pkglibdir}/mod_%{mod_name}{,-py3}.so
sed -e 's/mod_wsgi.so/mod_wsgi-py3.so/' %{SOURCE1} > $RPM_BUILD_ROOT%{_sysconfdir}/61_mod_wsgi-py3.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post py3
%service -q httpd restart

%postun py3
if [ "$1" = "0" ]; then
	%service -q httpd restart
fi

%files py3
%defattr(644,root,root,755)
%doc README.rst CREDITS.rst
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/*_mod_%{mod_name}-py3.conf
%attr(755,root,root) %{_pkglibdir}/mod_%{mod_name}-py3.so
%changelog
* Sat Mar 22 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/apache-mod_wsgi.git;a=log;h=master

* Sat Mar 22 2025 Jakub Bogusz <qboosh@pld-linux.org> 8425992
- updated to 5.0.2, should support pythons 3.8 .. 3.13

* Sat Mar 22 2025 Jakub Bogusz <qboosh@pld-linux.org> 6268396
- py2 part moved to apache-mod_wsgi-py2.spec

* Sat Mar 22 2025 Jakub Bogusz <qboosh@pld-linux.org> 579c0a2
- updated to 4.9.4

* Sat Mar 22 2025 Jakub Bogusz <qboosh@pld-linux.org> ff0b9e6
- updated dependencies, force non-interactive mv

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 72c0fca
- Release 3 (by relup.sh)

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 8576a3d
- python 3.13 rebuild

* Fri Apr 01 2022 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 43bbf7f
- up to 4.9.0

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 8448283
- rebuild with python 3.10

* Sun Nov 28 2021 Jan Rękorajski <baggins@pld-linux.org> a4dbcd1
- Release 3 (by relup.sh)

* Fri Feb 26 2021 Jan Rękorajski <baggins@pld-linux.org> f9eeb01
- release 2 (by relup.sh)

* Sat Nov 02 2019 Jan Rękorajski <baggins@pld-linux.org> 992cd37
- up to 4.6.8

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 3a56f35
- rebuild with python 3.8
- release 6 (by relup.sh)

* Thu Jul 05 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 746ce03
- release 5 (by relup.sh)

* Mon Apr 24 2017 Elan Ruusamäe <glen@delfi.ee> aee3997
- fix .rpmnew filename on trigger

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 3f13580
- python 3.6
- release 3 (by relup.sh)

* Fri Oct 21 2016 Jan Rękorajski <baggins@pld-linux.org> efbd6ce
- provide generic module name
- rel 2

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> a2ce93b
- rel 1

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 7f9b772
- py2/py3 cross conflicts

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 4e3e8b6
- add trigger to upgrade config from old package name

* Sat Oct 01 2016 Elan Ruusamäe <glen@delfi.ee> 1e85a36
- build python2/python3 versions

